## cuneiform 0.7.0+dfsg

=== cuneiform_src/CMakeLists.txt ===
add_subdirectory(Kern)

=== cuneiform_src/Kern/CMakeLists.txt ===
include_directories(include
h
hh
hhh
hdebug
hrk
hrkint
hrstr
fon/src
usage
)

# Hide non exported functions/variables
include(CheckCCompilerFlag)
if(CMAKE_COMPILER_IS_GNUCC AND NOT WIN32)
    check_c_compiler_flag("-fvisibility=hidden -DHAVE_GCCVISIBILITY" HAVE_GCCVISIBILITY)
    if (HAVE_GCCVISIBILITY)
	    add_definitions("-fvisibility=hidden -DHAVE_GCCVISIBILITY")
    endif()
endif()

# Stop MSVC complaints about POSIX functions.
if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    if(NOT MSVC60)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4996")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4996")
    endif()
endif()

add_definitions(-D_USE_RVERLINE_)

# CMake does not currently have direct support for ImageMagick.
include(FindPkgConfig)
pkg_check_modules(MAGICK ImageMagick++)
if(MAGICK_FOUND)
    set(USE_MAGICK TRUE)
    include_directories(${MAGICK_INCLUDE_DIRS})
    link_directories(${MAGICK_LIBRARY_DIRS})
else()
    message(STATUS "ImageMagick++ not found. Only uncompressed BMP images supported.")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/include/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/include/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

# Libdl is needed only on Apple and Linux (that I know of).
if(NOT WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    find_library(DL_LIB dl)
endif()

# Emulate Windows DLL symbol resolve order.
if(UNIX AND NOT APPLE)
  set(CMAKE_SHARED_LINKER_FLAGS "-Wl,-Bsymbolic")
endif()

if(MINGW)
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -mwindows")
endif()

include_directories(itigerole/sources/tiger/h)

set(LIBTYPE SHARED)

if(LIBTYPE STREQUAL SHARED)
    set(SNP_SRC ${CMAKE_CURRENT_SOURCE_DIR}/hdebug/__snp.c)
    message(STATUS "Adding __snp.c to individual libraries.")
    #add_library(snp SHARED hdebug/__snp.c)
    #set(SNP_LIBS snp)
endif()

add_subdirectory(ccom)
add_subdirectory(cstr)
add_subdirectory(rstr)
add_subdirectory(rpstr)
add_subdirectory(cline)
add_subdirectory(fon)
add_subdirectory(leo)
add_subdirectory(evn32)
add_subdirectory(cpage)
add_subdirectory(cimage)
add_subdirectory(cfio)
add_subdirectory(puma)
add_subdirectory(rline)
add_subdirectory(rcutp)
add_subdirectory(dif)
add_subdirectory(msk)
add_subdirectory(rling)
add_subdirectory(ctb)
add_subdirectory(rsadd)
add_subdirectory(std)
add_subdirectory(pass2)
add_subdirectory(rbal)
add_subdirectory(mmx)
add_subdirectory(r35)
add_subdirectory(cpu)
add_subdirectory(rdib)
add_subdirectory(loc)
add_subdirectory(ced)
add_subdirectory(exc)
add_subdirectory(rimage)
add_subdirectory(rverline)
add_subdirectory(rout)
add_subdirectory(rblock)
add_subdirectory(rselstr)
add_subdirectory(rfrmt)
add_subdirectory(rshelllines)
add_subdirectory(lns32)
add_subdirectory(rreccom)
add_subdirectory(smetric)
add_subdirectory(rneg)
add_subdirectory(rpic)
add_subdirectory(rstuff)
add_subdirectory(rmarker)
add_subdirectory(rcorrkegl)

set(RPSTR_LIBS rpstr rstr rling mmx32 pass2 rbal cline leo32 cpu32 r3532 rlings rsadd
fon32 msk32 std32 evn32 cstr ctb32 dif32 rcutp ccom)
set(PUMA_LIBS puma rcorrkegl rmarker rstuff rpic rline rneg smetric rreccom
lns32 rshelllines rfrmt rselstr rblock rout rverline rimage exc ced cpage
cimage loc32 rdib cfio)

add_library(windummy ${LIBTYPE} windummy.c)
target_link_libraries(windummy ${DL_LIB})
set_property(TARGET windummy PROPERTY COMPILE_DEFINITIONS __WINDUMMY__)

add_executable(cuneiform cuneiform-cli.cpp)
target_link_libraries(cuneiform puma ${MAGICK_LIBRARIES} ${DL_LIB})

install_dll(windummy)
install_exe(cuneiform)

=== cuneiform_src/Kern/ccom/CMakeLists.txt ===
include_directories(src)

add_definitions(-D__CCOM__) # Sets FUN_IMPO and FUN_EXPO properly.

add_library(ccom ${LIBTYPE}
src/ccom.c
src/ccom_loc.c)

install_dll(ccom)

=== cuneiform_src/Kern/cpu/CMakeLists.txt ===
add_definitions(-D__CPU__)

add_library(cpu32 ${LIBTYPE}
src/cpu.c
src/cpu32.c
)

set_property(TARGET cpu32 PROPERTY COMPILE_DEFINITIONS __CPU__)

install_dll(cpu32)

=== cuneiform_src/Kern/evn32/CMakeLists.txt ===
include_directories(src)

add_library(evn32 ${LIBTYPE}
src/compdata.c
src/compkit.c
src/evn.c
src/locompmn.c
src/rastror.c
src/v0compan.c
src/v0comper.c
src/v0compev.c
src/v0compgl.c
src/v0comprq.c
)
set_property(TARGET evn32 PROPERTY COMPILE_DEFINITIONS __EVN__)

target_link_libraries(evn32 dif32 windummy)

install_dll(evn32)

=== cuneiform_src/Kern/lns32/CMakeLists.txt ===
include_directories(BEFORE src)

add_definitions(-DDPUMA_SNAP) # See warning below.

add_library(lns32 ${LIBTYPE}
${SNP_SRC} # WARNING: not here in original VS solution.
src/bit_data.cpp
src/extrlns.cpp
src/fillgap3.cpp
src/fltbuf.cpp
src/frag.cpp
src/hliner.cpp
src/lbambuk.cpp
src/lns.cpp
src/lnscheck.cpp
src/lnsini.cpp
src/myassert.cpp
src/procline.cpp
src/puanso.cpp
src/rbambuk.cpp
src/rombabble.cpp
src/sbambuk.cpp
src/smooth.cpp
src/sweeper.cpp
src/tgreader.cpp
)
set_property(TARGET lns32 PROPERTY COMPILE_DEFINITIONS __LNS__)

target_link_libraries(lns32 cline std32 windummy)

install_dll(lns32)

=== cuneiform_src/Kern/msk/CMakeLists.txt ===
include_directories(src)

add_library(msk32 ${LIBTYPE} src/msk.c)
set_property(TARGET msk32 PROPERTY COMPILE_DEFINITIONS __MSK__)

target_link_libraries(msk32 mmx32 windummy)

install_dll(msk32)

=== cuneiform_src/Kern/r35/CMakeLists.txt ===
add_library(r3532 ${LIBTYPE}
src/r35.c)

set_property(TARGET r3532 PROPERTY COMPILE_DEFINITIONS __R35__)

target_link_libraries(r3532 mmx32 std32 windummy)

install_dll(r3532)

=== cuneiform_src/Kern/rcorrkegl/CMakeLists.txt ===
include_directories(BEFORE src/h)

add_library(rcorrkegl ${LIBTYPE}
${SNP_SRC}
src/cpp/cor_kegl.cpp
src/cpp/rcorrkegl.cpp
src/cpp/stdafx.cpp
)
set_property(TARGET rcorrkegl PROPERTY COMPILE_DEFINITIONS __RCORRKEGL__)

target_link_libraries(rcorrkegl cstr cpage)

install_dll(rcorrkegl)

=== cuneiform_src/Kern/rline/CMakeLists.txt ===
include_directories(BEFORE sources)

add_library(rline ${LIBTYPE}
${SNP_SRC}
sources/dll.cpp
sources/findlostlines.cpp
sources/newline.cpp
sources/rline.cpp
)
set_property(TARGET rline PROPERTY COMPILE_DEFINITIONS __RLINE__)

target_link_libraries(rline
cimage
cpage
lns32
rshelllines
)

install_dll(rline)

=== cuneiform_src/Kern/rling/CMakeLists.txt ===
# This subdirectory needs to be built two different times.
# The latter one needs different compiler definitions.

include_directories(BEFORE sources sources/h)
add_subdirectory(sources)

add_definitions(-DRLING_EXPORTS)

add_library(rling ${LIBTYPE}
sources/cpp/crled.cpp
sources/cpp/crling.cpp
#SOURCE=.\CRLing.rc
sources/cpp/crlmemory.cpp
sources/cpp/dll.cpp
sources/cpp/rlcontrol.cpp
sources/c/rling_ma.c
sources/c/spel2dic.c
sources/c/spel2voc.c
sources/c/spelabc.c
sources/c/spelart.c
sources/c/spelbuf.c
sources/c/spelchk.c
sources/c/speldat1.c
sources/c/speldat2.c
sources/c/speldici.c
sources/c/speldict.c
sources/c/speldvoc.c
sources/c/speledf1.c
sources/c/speledf2.c
sources/c/speledio.c
sources/c/spelfun.c
sources/c/spelloop.c
sources/c/spelout.c
sources/c/spelq.c
sources/c/spelset.c
sources/c/spelspec.c
sources/c/udictini.c
sources/c/udictuti.c
)
set_property(TARGET rling PROPERTY COMPILE_DEFINITIONS __RLING__)

target_link_libraries(rling cstr rlings)

install_dll(rling)

=== cuneiform_src/Kern/rpstr/CMakeLists.txt ===
include_directories(src)
include_directories(src/incl)
include_directories(src/capdrop)

add_library(rpstr ${LIBTYPE}
${SNP_SRC}
src/capdrop/cap_drop.c 
src/incl/cor_incl.c 
src/cor_spel.c 
src/rpstr.c 
src/vertstr.cpp)
set_property(TARGET rpstr PROPERTY COMPILE_DEFINITIONS __RPSTR__)

target_link_libraries(rpstr
ccom
cstr
rling
rstr
std32
)

install_dll(rpstr)

## cuneiform 0.7.0+dfsg.1

=== CMakeLists.txt ===
project(cuneiform C CXX)
cmake_minimum_required(VERSION 2.6.2)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR})

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir and try again.")
endif()

set(CF_VERSION_MAJOR "0")
set(CF_VERSION_MINOR "7")
set(CF_VERSION_PATCH "0")

set(CF_VERSION "${CF_VERSION_MAJOR}.${CF_VERSION_MINOR}.${CF_VERSION_PATCH}")

option(BUILD_TESTING "Enable CTest framework." OFF)

if(BUILD_TESTING)
  enable_testing()
  include(CTest)
  include(Dart)
endif(BUILD_TESTING)

include(install_files.cmake)

add_subdirectory(datafiles)
add_subdirectory(cuneiform_src)

=== cuneiform_src/Kern/ced/CMakeLists.txt ===
include_directories(h sources/h)

add_definitions(-D__CED__)

add_library(ced ${LIBTYPE}
sources/main/ced.cpp
sources/main/ced_func.cpp
sources/main/ced_func_old.cpp
sources/main/ced_func_rtf.cpp
sources/main/ced_struct_implem.cpp
sources/main/dll.cpp
sources/main/stdafx.cpp
sources/main/wrapper.cpp
)

target_link_libraries(ced cfio windummy)

install_dll(ced)

=== cuneiform_src/Kern/cfio/CMakeLists.txt ===
include_directories(BEFORE sources/h sources/cpp)

add_library(cfio ${LIBTYPE}
sources/cpp/ctcbase.cpp
sources/cpp/ctccontrol.cpp
sources/cpp/ctcfile.cpp
sources/cpp/ctcmemory.cpp
sources/cpp/ctcstorage.cpp
sources/cpp/dll_main.cpp
)

target_link_libraries(cfio windummy)

install_dll(cfio)

=== cuneiform_src/Kern/cimage/CMakeLists.txt ===
include_directories(BEFORE sources/main)

add_library(cimage ${LIBTYPE}
${SNP_SRC}
sources/main/cticontrol.cpp
sources/main/ctiimage.cpp
#sources/main/ctiimage.RC
sources/main/ctiimageheader.cpp
sources/main/ctiimagelist.cpp
sources/main/ctimask.cpp
sources/main/ctimaskline.cpp
sources/main/ctimasklinesegment.cpp
sources/main/ctimemory.cpp
sources/main/dll.cpp
)

set_property(TARGET cimage PROPERTY COMPILE_DEFINITIONS __CIMAGE__)

target_link_libraries(cimage cfio rdib)

install_dll(cimage)

=== cuneiform_src/Kern/cline/CMakeLists.txt ===
include_directories(sources/src/h)

add_library(cline ${LIBTYPE}
${SNP_SRC}
sources/src/main/clinebase.cpp
sources/src/cpp/clinefunc.cpp
sources/src/main/clinemain.cpp
sources/src/cpp/debug.cpp
sources/src/cpp/lcline.cpp
)
set_property(TARGET cline PROPERTY COMPILE_DEFINITIONS __CLINE__)

target_link_libraries(cline windummy)

install_dll(cline)

=== cuneiform_src/Kern/cpage/CMakeLists.txt ===
include_directories(BEFORE sources/cpp sources/main)

add_library(cpage ${LIBTYPE}
sources/cpp/backup.cpp
sources/cpp/block.cpp
sources/cpp/compress.cpp
sources/main/cpage.cpp
#sources/main/cpage.rc
sources/cpp/cpicture.cpp
sources/main/ctablex.cpp
sources/cpp/data.cpp
sources/cpp/defconvert.cpp
sources/main/dll_cpage.cpp
sources/main/mymem.cpp
sources/cpp/namedata.cpp
sources/cpp/page.cpp
sources/cpp/picture.cpp
sources/cpp/table.cpp
sources/cpp/tableclass.cpp
)
set_property(TARGET cpage PROPERTY COMPILE_DEFINITIONS __CPAGE__)

target_link_libraries(cpage windummy)

install_dll(cpage)

=== cuneiform_src/Kern/cstr/CMakeLists.txt ===
include_directories(src)

add_library(cstr ${LIBTYPE}
src/cgraph.cpp
src/cstr.c)
set_property(TARGET cstr PROPERTY COMPILE_DEFINITIONS __CSTR__)

target_link_libraries(cstr ccom)

install_dll(cstr)

=== cuneiform_src/Kern/ctb/CMakeLists.txt ===
add_library(ctb32 ${LIBTYPE}
src/ctb_aln.c
src/ctb_cnvm.c
src/ctb_gray.c
src/ctb_oper.c
src/ctb_pack.c
src/ctb_prot.c
src/ctb_recr.c
src/ctb_tool.c
)
set_property(TARGET ctb32 PROPERTY COMPILE_DEFINITIONS __CTB__)

target_link_libraries(ctb32 windummy)

install_dll(ctb32)

=== cuneiform_src/Kern/dif/CMakeLists.txt ===
include_directories(BEFORE src)

add_library(dif32 ${LIBTYPE}
src/dif.c
src/diffr.c
src/diffrb.c
src/sticchar.c
src/sticdif.c
src/stictool.c
)
set_property(TARGET dif32 PROPERTY COMPILE_DEFINITIONS __DIF__)

install_dll(dif32)

=== cuneiform_src/Kern/exc/CMakeLists.txt ===
include_directories(BEFORE src)

add_library(exc ${LIBTYPE}
src/compdata.c
src/compkit.c
src/extrcomp.c
src/locompmn.c
src/matrix.c
src/v0compan.c
src/v0compgl.c
src/v0compmn.c
)
set_property(TARGET exc PROPERTY COMPILE_DEFINITIONS __EXC__)

target_link_libraries(exc loc32 ccom evn32)

install_dll(exc)

=== cuneiform_src/Kern/fon/CMakeLists.txt ===
add_library(fon32 ${LIBTYPE}
src/clu_best.c
src/clu_div.c
src/clu_lang.c
src/clu_test.c
src/cutoff.c
src/dist_bou.c
src/distance.c
src/fon_snap.c
src/fonrec.c
src/p2_addcl.c
src/p2_clu.c
src/p2_dsbit.c
src/p2_mem.c
src/p2_thick.c
src/utilctb.c
)
set_property(TARGET fon32 PROPERTY COMPILE_DEFINITIONS __FON__)

target_link_libraries(fon32 cstr ctb32)

install_dll(fon32)

=== cuneiform_src/Kern/leo/CMakeLists.txt ===
include_directories(BEFORE src)

add_definitions(-DDPUMA_SNAP) # See warning below.

add_library(leo32 ${LIBTYPE}
${SNP_SRC} # WARNING: was not in the original dsp files, but I had to add this to make it link.
src/leo.c
src/leo_cont.c
src/leo_dll.c
src/leo_ind.c
src/leo_prn.c
src/leo_size.c
src/leo_stic.c
)
set_property(TARGET leo32 PROPERTY COMPILE_DEFINITIONS __LEO__)

target_link_libraries(leo32
cpu32
ctb32
dif32
evn32
fon32
msk32
r3532
std32
)

install_dll(leo32)

=== debian/changelog ===
cuneiform (0.7.0+dfsg.1-1) unstable; urgency=low

  * QA upload
  * Repacked upstream tarball without cuneiform_src/Kern/rout/wtypes.h
    since its licence has been doubted, and since it isn't used anyway.
    (closes: #583603). Removed mention of that file from debian/copyright.
  * Recompiled against libmagick++3 (closes: #575420).
  * Bumped dependency on debhelper to >= 7.0.50~.
  * Source format 3.0 (quilt): no change

 -- Ralf Treinen <treinen@debian.org>  Tue, 29 Jun 2010 20:12:53 +0200

cuneiform (0.7.0+dfsg-5) unstable; urgency=low

  * Updating package to standards version 3.8.3.
  * Removing vcs fields.
  * Orphaning package.

 -- Daniel Baumann <daniel@debian.org>  Thu, 27 Aug 2009 10:42:31 +0200

cuneiform (0.7.0+dfsg-4) unstable; urgency=low

  * Minimalizing rules file.

 -- Daniel Baumann <daniel@debian.org>  Wed, 29 Jul 2009 21:44:01 +0200

cuneiform (0.7.0+dfsg-3) unstable; urgency=low

  * Avoiding circular depends (Closes: #531707).
  * Updating standards version to 3.8.2.
  * Adding README.Debian with a note about non-free.

 -- Daniel Baumann <daniel@debian.org>  Fri, 10 Jul 2009 17:58:10 +0200

cuneiform (0.7.0+dfsg-2) unstable; urgency=low

  * Adding Autobuild field in control (Closes: #531363).
  * Updating version and date in manpage.
  * Building binaries with optimization.

 -- Daniel Baumann <daniel@debian.org>  Mon, 01 Jun 2009 09:18:01 +0200

cuneiform (0.7.0+dfsg-1) unstable; urgency=low

  * Using correct rfc-2822 date formats in changelog.
  * Updating to standards 3.8.1.
  * Merging upstream version 0.7.0+dfsg.
  * Passing libdir to cmake (Closes: #531277).

 -- Daniel Baumann <daniel@debian.org>  Sun, 31 May 2009 19:54:52 +0200

cuneiform (0.6.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #496264).
  * Rebuild upstream tarball without win32 binaries.
  * The source for the .dat files is unknown, therefore uploading to non-free,
    see comments in http://bugs.debian.org/496264 from Jussi Pakkanen.

 -- Daniel Baumann <daniel@debian.org>  Mon, 06 Apr 2009 02:38:00 +0200

=== debian/control ===
Source: cuneiform
Section: non-free/graphics
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6.2),
 libmagick++-dev
Standards-Version: 3.8.3
Homepage: http://launchpad.net/cuneiform-linux/
Vcs-Browser: http://git.debian.net/?p=debian/cuneiform.git
Vcs-Git: git://git.debian.net/git/debian/cuneiform.git
XS-Autobuild: yes

Package: cuneiform
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, cuneiform-common
Description: multi-language OCR system
 Cuneiform is an OCR system. In addition to text recognition it also does layout
 analysis and text format recognition. Cuneiform supports several languages.

Package: cuneiform-common
Architecture: all
Depends: ${misc:Depends}
Description: multi-language OCR system (common)
 Cuneiform is an OCR system. In addition to text recognition it also does layout
 analysis and text format recognition. Cuneiform supports several languages.
 .
 This package contains the common files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh ${@}

dfsg:
	rm -rf cuneiform_src/Addfiles
	rm -rf cuneiform_src/Kern/icrashreport

override_dh_auto_clean:
	dh_auto_clean

	rm -rf build

override_dh_auto_build:
	mkdir -p build
	cd build && cmake -DCMAKE_BUILD_TYPE=relwithdebinfo -DCMAKE_EXE_LINKER_FLAGS:STRING=-Wl,--as-needed -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_RPATH=/usr/lib/cuneiform ..
	$(MAKE) -C build

override_dh_auto_install:
	$(MAKE) -C build DESTDIR=$(CURDIR)/debian/tmp install

## cuneiform 1.1.0%2Bdfsg

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg// \
https://launchpad.net/cuneiform-linux \
https://launchpad.net/cuneiform-linux/[0-9.]+/.*/[+]download/cuneiform-linux-([0-9.]+)[.]tar[.]bz2

## cuneiform 1.1.0+dfsg

=== CMakeLists.txt ===
project(cuneiform C CXX)
cmake_minimum_required(VERSION 2.6.2)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})
if(WIN32)
  set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR})
endif()

if(PROJECT_BINARY_DIR STREQUAL PROJECT_SOURCE_DIR)
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CF_VERSION_MAJOR "1")
set(CF_VERSION_MINOR "1")
set(CF_VERSION_PATCH "0")

set(CF_VERSION "${CF_VERSION_MAJOR}.${CF_VERSION_MINOR}.${CF_VERSION_PATCH}")
# Increment this manually whenever breaking ABI.
# http://tldp.org/HOWTO/Program-Library-HOWTO/shared-libraries.html#AEN135
set(ABI_VERSION 0)

option(BUILD_TESTING "Enable CTest framework." OFF)

if(BUILD_TESTING)
  enable_testing()
  include(CTest)
  include(Dart)
  add_subdirectory(images)
endif()

include(install_files.cmake)

#add_subdirectory(tests)
add_subdirectory(headers)
add_subdirectory(datafiles)
add_subdirectory(cuneiform_src)

=== cuneiform_src/CMakeLists.txt ===
include_directories(Kern/include
Kern/h
Kern/hh
Kern/hhh
Kern/hdebug
Kern/hrk
Kern/hrkint
Kern/hrstr
Kern/fon/src
Kern/usage
)

# Hide non exported functions/variables
include(CheckCCompilerFlag)
if(CMAKE_COMPILER_IS_GNUCC AND NOT WIN32)
    check_c_compiler_flag("-fvisibility=hidden -DHAVE_GCCVISIBILITY" HAVE_GCCVISIBILITY)
    if (HAVE_GCCVISIBILITY)
	    add_definitions("-fvisibility=hidden -DHAVE_GCCVISIBILITY")
    endif()
endif()

# Stop MSVC complaints about POSIX functions.
if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    if(NOT MSVC60)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4996")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4996")
    endif()
endif()


INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES (endian.h HAVE_ENDIAN_H)

add_definitions(-D_USE_RVERLINE_)

find_package(ImageMagick COMPONENTS Magick++)
if(ImageMagick_Magick++_FOUND)
    set(USE_MAGICK TRUE)
    include_directories(${ImageMagick_Magick++_INCLUDE_DIR})
    message(STATUS "ImageMagick++ found at ${ImageMagick_Magick++_INCLUDE_DIR}.")
    set(cli_ext_libs ${ImageMagick_Magick++_LIBRARY})
else()
    set(USE_MAGICK FALSE)
    message(STATUS "ImageMagick++ not found. Only uncompressed BMP images supported.")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Kern/include/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/Kern/include/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/Kern/include)

# Libdl is needed only on Apple and Linux (that I know of).
if(NOT WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
    find_library(DL_LIB dl)
endif()

# Emulate Windows DLL symbol resolve order.
if(UNIX AND NOT APPLE)
  set(CMAKE_SHARED_LINKER_FLAGS "-Wl,-Bsymbolic")
endif()

if(MINGW)
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -mwindows")
endif()

add_subdirectory(Kern)
add_subdirectory(cli)

=== datafiles/CMakeLists.txt ===
file(GLOB datfiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.dat)

foreach(i ${datfiles})
    install(FILES ${i} DESTINATION ${RELATIVE_DATADIR}) 
endforeach()

=== headers/CMakeLists.txt ===
install(FILES cuneiform.h DESTINATION include)

=== images/CMakeLists.txt ===
set(test_script ${CMAKE_CURRENT_SOURCE_DIR}/test_output.sh)

macro(output_test testname imagefile)
    add_test(${testname} ${test_script} ${CMAKE_CURRENT_SOURCE_DIR}/${imagefile} ${ARGN})
endmacro()

output_test(BasicTest phototest.tif --singlecolumn)

=== cuneiform_src/Kern/CMakeLists.txt ===
set(LIBTYPE SHARED)

if(LIBTYPE STREQUAL SHARED)
    set(SNP_SRC ${CMAKE_CURRENT_SOURCE_DIR}/hdebug/__snp.c)
    message(STATUS "Adding __snp.c to individual libraries.")
    #add_library(snp SHARED hdebug/__snp.c)
    #set(SNP_LIBS snp)
endif()

add_subdirectory(ccom)
add_subdirectory(cstr)
add_subdirectory(rstr)
add_subdirectory(rpstr)
add_subdirectory(cline)
add_subdirectory(fon)
add_subdirectory(leo)
add_subdirectory(evn32)
add_subdirectory(cpage)
add_subdirectory(cimage)
add_subdirectory(cfio)
add_subdirectory(puma)
add_subdirectory(rline)
add_subdirectory(rcutp)
add_subdirectory(dif)
add_subdirectory(msk)
add_subdirectory(rling)
add_subdirectory(ctb)
add_subdirectory(rsadd)
add_subdirectory(std)
add_subdirectory(pass2)
add_subdirectory(rbal)
add_subdirectory(mmx)
add_subdirectory(r35)
add_subdirectory(cpu)
add_subdirectory(rdib)
add_subdirectory(loc)
add_subdirectory(ced)
add_subdirectory(exc)
add_subdirectory(rimage)
add_subdirectory(rverline)
add_subdirectory(rout)
add_subdirectory(rblock)
add_subdirectory(rselstr)
add_subdirectory(rfrmt)
add_subdirectory(rshelllines)
add_subdirectory(lns32)
add_subdirectory(rreccom)
add_subdirectory(smetric)
add_subdirectory(rneg)
add_subdirectory(rpic)
add_subdirectory(rstuff)
add_subdirectory(rmarker)
add_subdirectory(rcorrkegl)

set(RPSTR_LIBS rpstr rstr rling mmx32 pass2 rbal cline leo32 cpu32 r3532 rlings rsadd
fon32 msk32 std32 evn32 cstr ctb32 dif32 rcutp ccom)
set(PUMA_LIBS puma rcorrkegl rmarker rstuff rpic rline rneg smetric rreccom
lns32 rshelllines rfrmt rselstr rblock rout rverline rimage exc ced cpage
cimage loc32 rdib cfio)

include_directories(itigerole/sources/tiger/h)

add_subdirectory(cfcompat)

=== cuneiform_src/cli/CMakeLists.txt ===
add_executable(cuneiform-cli cuneiform-cli.cpp)
set_target_properties(cuneiform-cli PROPERTIES OUTPUT_NAME cuneiform)
target_link_libraries(cuneiform-cli cuneiform ${cli_ext_libs} ${DL_LIB})
install_exe(cuneiform-cli)

=== cuneiform_src/Kern/ccom/CMakeLists.txt ===
--- 
+++ 
@@ -6,4 +6,4 @@
 src/ccom.c
 src/ccom_loc.c)
 
-install_dll(ccom)
+library_hook(ccom)

=== cuneiform_src/Kern/ced/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,6 @@
 sources/main/wrapper.cpp
 )
 
-target_link_libraries(ced cfio windummy)
+target_link_libraries(ced cfio cfcompat)
 
-install_dll(ced)
+library_hook(ced)

=== cuneiform_src/Kern/cfcompat/CMakeLists.txt ===
add_library(cfcompat ${LIBTYPE} cfcompat.c)
target_link_libraries(cfcompat ${DL_LIB})
set_property(TARGET cfcompat PROPERTY COMPILE_DEFINITIONS __CFCOMPAT__)

library_hook(cfcompat)

=== cuneiform_src/Kern/cfio/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,6 @@
 sources/cpp/dll_main.cpp
 )
 
-target_link_libraries(cfio windummy)
+target_link_libraries(cfio cfcompat)
 
-install_dll(cfio)
+library_hook(cfio)

=== cuneiform_src/Kern/cimage/CMakeLists.txt ===
--- 
+++ 
@@ -18,4 +18,4 @@
 
 target_link_libraries(cimage cfio rdib)
 
-install_dll(cimage)
+library_hook(cimage)

=== debian/changelog ===
cuneiform (1.1.0+dfsg-4) unstable; urgency=low

  * Improve the test suite:
    + Don't rely on TMPDIR being empty or unset.
    + Print “FAIL” instead of “ERROR” in case of test failure.
    + Better error handling.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 24 Apr 2012 20:16:21 +0200

cuneiform (1.1.0+dfsg-3) unstable; urgency=low

  * Bump minimum required debhelper version to 8.1.3 (for multi-arch support).
  * Bump debhelper compatibility level to 8.
    + Exclude private libraries from being processed by dh_makeshlibs.
  * Use $() construct (rather than backticks) in the get-orig-source script.
  * Bump standards version to 3.9.3.
    + Update debian/copyright URI.
  * Drop lintian overrides for binary-or-shlib-defines-rpath; not needed
    anymore.
  * Update patch headers.
  * Move most testing logic from debian/rules to debian/tests/. Implement
    DEP-8 tests.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 24 Apr 2012 00:13:05 +0200

cuneiform (1.1.0+dfsg-2) unstable; urgency=low

  * Bump minimum required version of cmake to 2.8.2 (closes: #628732). Our
    GraphicsMagick patch requires pkg_check_modules to support the QUIET
    option, which was added in cmake 2.8.2 RC 1. Thanks to Marc Straub for the
    bug report.
  * Remove bogus debian/tests/include-binaries.
  * Overhaul debian/rules. Stop using dh.
  * Adjust *.install files, so that it's possible to build the
    cuneiform-common package without building any code.
  * Drop Vcs-* fields.
  * Link the r35 library with libm.
  * Compress binary packages with xz.
    + Add pre-dependency on dpkg >= 1.15.6.
  * Multi-archify:
    + Make cuneiform and cuneiform-common ‘Multi-Arch: foreign’.
    + Make libcuneiform0 and libcuneiform-dev ‘Multi-Arch: same’.
    + Add ‘Pre-Depends: ${misc:Pre-Depends}’ to libcuneiform0.
    + Install shared libraries to /usr/lib/$(DEB_HOST_MULTIARCH) rather than
      /usr/lib.
    + Install lintian override for binary-or-shlib-defines-rpath (see bug
      #646817).
    + Bump minimum required version of dpkg-dev to 1.16.
  * Pass CPPFLAGS (get from dpkg-buildflags) to cmake
  * Call dpkg-buildflags lazily.
  * Use versioned URL for copyright file format.

 -- Jakub Wilk <jwilk@debian.org>  Thu, 27 Oct 2011 16:51:13 +0200

cuneiform (1.1.0+dfsg-1) unstable; urgency=low

  * Upload to unstable.
  * New upstream release.
    + Drop patches: c-assert.diff, cuneiform.h-rename-*.diff,
      slovenian-slv.diff, soname.diff, swapytes.diff. All applied upstream.
    + Refresh the remaining patches.
    + Update *.install files.
    + Fix incorrect use of va_list (closes: #596917).
  * Re-add c-assert.diff to fix another instance of custom assert() macro.
  * Use stricter check level for dpkg-gensymbols.
  * Bump standards version to 3.9.2 (no changes needed).

 -- Jakub Wilk <jwilk@debian.org>  Sat, 30 Apr 2011 13:16:24 +0200

cuneiform (1.0.0+dfsg-3) experimental; urgency=low

  * Backport upstream patch to change SONAME to ‘libcuneiform.so.0’.
    [soname.diff]
  * Backport upstream patches to rename various names in order to prevent name
    collisions. [cuneiform.h-rename-*.diff]
  * Remove trailing whitespace in debian/control.
  * New binary packages: libcuneiform-dev, libcuneiform0 (closes: #598616).
    + Move dependency on cuneiform-common from cuneiform to libcuneiform0.
    + Move /usr/lib files from cuneiform to libcuneiform0.
    + Move libcuneiform.so.* from /usr/lib/cuneiform/ to /usr/lib/.
    + No longer disable call to dh_makeshlibs.
    + Add symbols file.
    + Add new packages to vrms reasons file.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 28 Feb 2011 21:12:01 +0100

cuneiform (1.0.0+dfsg-2) unstable; urgency=low

  * Upload to unstable.
  * Explicitly build-depend on pkg-config. Thanks to Stefano Rivera for the
    bug report.
  * Add Vcs-* fields.
  * Use the standard C assert() macro, rather than custom Cuneiform one.
    [c-assert.diff]
  * Pass CFLAGS, CXXFLAGS and LDFLAGS (get from dpkg-buildflags) to cmake
    (closes: #608345). Thanks to Sami Liedes for the bug report.
    + Build depend on dpkg-dev (>= 1.15.7).
  * Pass --parallel to dh.
    + Bump debhelper minimum version to 7.4.10.
  * Update debian/copyright to the latest DEP-5 version.
  * Bump year in debian/copyright.
  * Explicitly link to GraphicsMagick (rather than via the ImageMagick
    compatibility layer).
  * Don't ship /usr/lib/cuneiform/*.so symlinks. These libraries are
    considered private, at least until #598616 is fixed.
  * Rename some private variables in debian/rules to make them lowercase.
  * Update patch headers.
  * Provide proper ‘build-arch’ and ‘build-indep’ targets in debian/rules.
  * Document input format in the manual page (closes: #572061). Thanks to
    Janusz S. Bień for the bug report.
  * Use ‘slv’ (rather than ‘slo’) as language code for Slovenian.
    [slovenian-slv.diff]
  * Fix package description: Slovenian is supported, Slovak is not.
  * Improve documentation of the language (-l) option (closes: #602512).
    Thanks to Jari Aalto for the bug report.
  * Install reasons file for vrms.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 26 Jan 2011 21:53:07 +0100

cuneiform (1.0.0+dfsg-1) experimental; urgency=low

  * New upstream release (closes: #575419).
  * New maintainer (closes: #543893).
  * Document in README.source how to repackage upstream tarball.
  * Update debian/copyright.
    + Document that the package is auto-buildable.
    + Document which files were stripped from the upstream tarball.
    + Convert to the DEP-5 format.
  * Drop README.Debian, no longer needed.
  * Rewrite debian/rules from scratch using dh.
    + Bump debhelper minimum version to 7.4.4 (for cmake support).
    + Turn on MAKE_VERBOSE_MAKEFILE.
    + Disable call to dh_makeshlibs to avoid creation of spurious
      calls to ldconfig in postrm/postinst.
    + Add get-orig-source target.
  * Remove unused overrides.
  * Link to GraphicsMagick rather than ImageMagick:


=== debian/control ===
Source: cuneiform
Section: non-free/graphics
Priority: optional
Maintainer: Jakub Wilk <jwilk@debian.org>
Build-Depends: debhelper (>= 8.1.3), dpkg-dev (>= 1.16), cmake (>= 2.8.2),
  libgraphicsmagick++1-dev, pkg-config
Standards-Version: 3.9.3
Homepage: http://launchpad.net/cuneiform-linux/
XS-Autobuild: yes

Package: cuneiform
Architecture: any
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: ocrodjvu (<< 0.4.2)
Description: multi-language OCR system
 Cuneiform is an OCR system. In addition to text recognition it also does
 layout analysis and text format recognition.
 .
 The following languages are supported: Bulgarian, Croatian, Czech, Danish,
 Dutch, English, Estonian, French, German, Hungarian, Italian, Latvian,
 Lithuanian, Polish, Portuguese, Romanian, Russian, Serbian, Slovenian,
 Spanish, Swedish, Turkish and Ukrainian.

Package: cuneiform-common
Architecture: all
Multi-Arch: foreign
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${misc:Depends}
Description: multi-language OCR system (common)
 Cuneiform is an OCR system. In addition to text recognition it also does layout
 analysis and text format recognition.
 .
 The following languages are supported: Bulgarian, Croatian, Czech, Danish,
 Dutch, English, Estonian, French, German, Hungarian, Italian, Latvian,
 Lithuanian, Polish, Portuguese, Romanian, Russian, Serbian, Slovenian,
 Spanish, Swedish, Turkish and Ukrainian.
 .
 This package contains the common files.

Package: libcuneiform-dev
Section: non-free/libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${misc:Depends}, libcuneiform0 (= ${binary:Version})
Description: multi-language OCR system (development)
 Cuneiform is an OCR system. In addition to text recognition it also does layout
 analysis and text format recognition.
 .
 The following languages are supported: Bulgarian, Croatian, Czech, Danish,
 Dutch, English, Estonian, French, German, Hungarian, Italian, Latvian,
 Lithuanian, Polish, Portuguese, Romanian, Russian, Serbian, Slovenian,
 Spanish, Swedish, Turkish and Ukrainian.
 .
 This package contains the development support files.

Package: libcuneiform0
Section: non-free/libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}, dpkg (>= 1.15.6)
Depends: ${misc:Depends}, ${shlibs:Depends}, cuneiform-common
Breaks: cuneiform (<< 1.0.0+dfsg-3~)
Replaces: cuneiform (<< 1.0.0+dfsg-3~)
Description: multi-language OCR system (shared library)
 Cuneiform is an OCR system. In addition to text recognition it also does layout
 analysis and text format recognition.
 .
 The following languages are supported: Bulgarian, Croatian, Czech, Danish,
 Dutch, English, Estonian, French, German, Hungarian, Italian, Latvian,
 Lithuanian, Polish, Portuguese, Romanian, Russian, Serbian, Slovenian,
 Spanish, Swedish, Turkish and Ukrainian.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

here = $(dir $(firstword $(MAKEFILE_LIST)))/..
upstream_version = $(shell cd $(here) && dpkg-parsechangelog | sed -n -r -e '/^Version: ([0-9.]+)([+]dfsg).*/ { s//\1/; p; q; }')

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = $(shell dpkg-buildflags --get CFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS) $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

cmake_options = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=relwithdebinfo \
	-DCMAKE_C_FLAGS_RELWITHDEBINFO="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELWITHDEBINFO="$(CXXFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO="$(LDFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO="$(LDFLAGS)" \
	-DCMAKE_INSTALL_RPATH=/usr/lib/$(DEB_HOST_MULTIARCH)/cuneiform

parallel = -j$(or $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS))),1)

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
unexport CFLAGS
unexport CXXFLAGS
unexport LDFLAGS

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

# build and build-{arch,indep} targets
# ====================================

.PHONY: build build-arch build-indep

build: build-arch build-indep

build-indep:
# Nothing to do here.

build-arch: obj/build-stamp obj/test-stamp

obj/CMakeCache.txt:
	dh_testdir
	mkdir -p obj
	cd obj && cmake .. $(cmake_options)

obj/build-stamp: obj/CMakeCache.txt
	dh_testdir
	$(MAKE) $(parallel) -C obj
	touch $(@)

obj/test-stamp:
	dh_testdir
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	CF_DATADIR=$(CURDIR)/datafiles/ debian/tests/ground-truth obj/cuneiform
endif
	touch $(@)


# binary and binary-{arch,indep} targets
# ======================================

.PHONY: binary binary-arch binary-indep

binary: binary-arch binary-indep

binary-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep -a
	$(MAKE) -C obj install DESTDIR=$(CURDIR)/debian/tmp/
	dh_install -p libcuneiform-dev '/usr/lib*/libcuneiform.so' /usr/lib/$(DEB_HOST_MULTIARCH)/
	dh_install -p libcuneiform0 '/usr/lib*/lib*.so.*' /usr/lib/$(DEB_HOST_MULTIARCH)/cuneiform/
	cd debian/libcuneiform0/usr/lib/$(DEB_HOST_MULTIARCH)/cuneiform/ && mv -t ../ libcuneiform.so.*
	dh_install -a
	dh_installdocs -a
	dh_installchangelogs -a
	dh_installman -a
	dh_compress -a
	dh_fixperms -a
	dh_strip -a
	dh_makeshlibs -a -X/cuneiform/
	dh_shlibdeps -a
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a -- -Zxz

binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep -i -X tmp
	dh_install -i
	dh_installdocs -i
	dh_installchangelogs -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i -- -Zxz

# clean target
# ============

.PHONY: clean
clean:
	dh_testdir
	dh_clean
	rm -rf obj

# get-orig-source target
# ======================

.PHONY: get-orig-source
get-orig-source:
	sh $(here)/debian/get-orig-source.sh $(upstream_version)

# vim:ts=4 sw=4 noet

=== debian/tests/control ===
Tests: ground-truth
Features: no-build-needed
Depends: cuneiform

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg// \
http://launchpad.net/cuneiform-linux \
http://launchpad.net/cuneiform-linux/[0-9.]+/.*/[+]download/cuneiform-linux-([0-9.]+)[.]tar[.]bz2
